/**
 * Copyright 2013 Jeanfrancois Arcand
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * IE streaming/XDR supports is copied/highly inspired by http://code.google.com/p/jquery-stream/
 *
 * Copyright 2011, Donghwan Kim
 * Licensed under the Apache License, Version 2.0
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * LocalStorage supports is copied/highly inspired by https://github.com/flowersinthesand/jquery-socket
 * Copyright 2011, Donghwan Kim
 * Licensed under the Apache License, Version 2.0
 * http://www.apache.org/licenses/LICENSE-2.0
 * */
/**
 * Official documentation of this library: https://github.com/Atmosphere/atmosphere/wiki/jQuery.atmosphere.js-API
 */
jQuery.atmosphere=function(){jQuery(window).bind("unload.atmosphere",function(){jQuery.atmosphere.unsubscribe()});jQuery(window).bind("offline",function(){jQuery.atmosphere.unsubscribe()});jQuery(window).keypress(function(d){27===d.keyCode&&d.preventDefault()});var t=function(d){for(var g,h=/^(.*?):[ \t]*([^\r\n]*)\r?$/mg,m={};g=h.exec(d);)m[g[1]]=g[2];return m};return{version:"2.1.2-jquery",uuid:0,requests:[],callbacks:[],onError:function(d){},onClose:function(d){},onOpen:function(d){},onMessage:function(d){},
onReconnect:function(d,g){},onMessagePublished:function(d){},onTransportFailure:function(d,g){},onLocalMessage:function(d){},onClientTimeout:function(d){},onFailureToReconnect:function(d,g){},AtmosphereRequest:function(d){function g(b){n();X=!0;I=!1;B=0;C=K=y=l=null;c=jQuery.extend(c,b);c.mrequest=c.reconnect;c.reconnect||(c.reconnect=!0)}function h(){if(c.shared){w=m(c);if(null!=w&&("debug"===c.logLevel&&jQuery.atmosphere.debug("Storage service available. All communication will be local"),w.open(c)))return;
"debug"===c.logLevel&&jQuery.atmosphere.debug("No Storage service available.");w=null}c.firstMessage=0==jQuery.atmosphere.uuid?!0:!1;c.isOpen=!1;c.ctime=jQuery.now();0===c.uuid&&(c.uuid=jQuery.atmosphere.uuid);c.closedByClientTimeout=!1;"websocket"!==c.transport&&"sse"!==c.transport?Q(c):"websocket"===c.transport?null!=c.webSocketImpl||window.WebSocket||window.MozWebSocket?Y(!1):L("Websocket is not supported, using request.fallbackTransport ("+c.fallbackTransport+")"):"sse"===c.transport&&(window.EventSource?
k(!1):L("Server Side Events(SSE) is not supported, using request.fallbackTransport ("+c.fallbackTransport+")"))}function m(b){function a(a){a=jQuery.parseJSON(a);var f=a.data;if("c"===a.target)switch(a.type){case "open":q("opening","local",c);break;case "close":g||(g=!0,"aborted"===f.reason?R():f.heir===F?h():setTimeout(function(){h()},100));break;case "message":G(f,"messageReceived",200,b.transport);break;case "localMessage":ba(f)}}function e(){var a=RegExp("(?:^|; )("+encodeURIComponent(r)+")=([^;]*)").exec(document.cookie);
if(a)return jQuery.parseJSON(decodeURIComponent(a[2]))}var f,d,g,r="atmosphere-"+b.url,ca={storage:function(){if(jQuery.atmosphere.supportStorage()){var c=window.localStorage,f=function(a){return jQuery.parseJSON(c.getItem(r+"-"+a))},e=function(a,b){c.setItem(r+"-"+a,jQuery.stringifyJSON(b))};return{init:function(){e("children",f("children").concat([F]));jQuery(window).on("storage.socket",function(b){b=b.originalEvent;b.key===r&&b.newValue&&a(b.newValue)});return f("opened")},signal:function(a,b){c.setItem(r,
jQuery.stringifyJSON({target:"p",type:a,data:b}))},close:function(){var a,c=f("children");jQuery(window).off("storage.socket");c&&(a=jQuery.inArray(b.id,c),-1<a&&(c.splice(a,1),e("children",c)))}}}},windowref:function(){var b=window.open("",r.replace(/\W/g,""));if(b&&!b.closed&&b.callbacks)return{init:function(){b.callbacks.push(a);b.children.push(F);return b.opened},signal:function(a,c){!b.closed&&b.fire&&b.fire(jQuery.stringifyJSON({target:"p",type:a,data:c}))},close:function(){if(!g){var c=b.callbacks,
f=jQuery.inArray(a,c);-1<f&&c.splice(f,1);c=b.children;f=jQuery.inArray(F,c);-1<f&&c.splice(f,1)}}}}};if((f=e())&&!(1E3<jQuery.now()-f.ts)&&(d=ca.storage()||ca.windowref()))return{open:function(){var c;S=setInterval(function(){var b=f;(f=e())&&b.ts!==f.ts||a(jQuery.stringifyJSON({target:"c",type:"close",data:{reason:"error",heir:b.heir}}))},1E3);(c=d.init())&&setTimeout(function(){q("opening","local",b)},50);return c},send:function(a){d.signal("send",a)},localSend:function(a){d.signal("localSend",
jQuery.stringifyJSON({id:F,event:a}))},close:function(){I||(clearInterval(S),d.signal("close"),d.close())}}}function s(){function b(a){a=jQuery.parseJSON(a);var b=a.data;if("p"===a.target)switch(a.type){case "send":Z(b);break;case "localSend":ba(b);break;case "close":R()}}function a(){document.cookie=$+"="+encodeURIComponent(jQuery.stringifyJSON({ts:jQuery.now()+1,heir:(e.get("children")||[])[0]}))+"; path=/"}var e,f="atmosphere-"+c.url,d={storage:function(){if(jQuery.atmosphere.supportStorage()){var a=
window.localStorage;return{init:function(){jQuery(window).on("storage.socket",function(a){a=a.originalEvent;a.key===f&&a.newValue&&b(a.newValue)})},signal:function(b,c){a.setItem(f,jQuery.stringifyJSON({target:"c",type:b,data:c}))},get:function(b){return jQuery.parseJSON(a.getItem(f+"-"+b))},set:function(b,c){a.setItem(f+"-"+b,jQuery.stringifyJSON(c))},close:function(){jQuery(window).off("storage.socket");a.removeItem(f);a.removeItem(f+"-opened");a.removeItem(f+"-children")}}}},windowref:function(){var a=
f.replace(/\W/g,""),c=(jQuery('iframe[name="'+a+'"]')[0]||jQuery('<iframe name="'+a+'" />').hide().appendTo("body")[0]).contentWindow;return{init:function(){c.callbacks=[b];c.fire=function(a){var b;for(b=0;b<c.callbacks.length;b++)c.callbacks[b](a)}},signal:function(a,b){!c.closed&&c.fire&&c.fire(jQuery.stringifyJSON({target:"c",type:a,data:b}))},get:function(a){return c.closed?null:c[a]},set:function(a,b){c.closed||(c[a]=b)},close:function(){}}}};N=function(a){e.signal("message",a)};e=d.storage()||
d.windowref();e.init();"debug"===c.logLevel&&jQuery.atmosphere.debug("Installed StorageService "+e);e.set("children",[]);null==e.get("opened")||e.get("opened")||e.set("opened",!1);$=encodeURIComponent(f);a();S=setInterval(a,1E3);D=e}function q(b,a,p){c.shared&&"local"!==a&&s();null!=D&&D.set("opened",!0);p.close=function(){R()};0<B&&"re-connecting"===b?(p.isReopen=!0,la(e)):null==e.error&&(e.request=p,p=e.state,e.state=b,b=e.transport,e.transport=a,a=e.responseBody,x(),e.responseBody=a,e.state=p,
e.transport=b)}function da(b){b.transport="jsonp";var a=c;null!=b&&"undefined"!==typeof b&&(a=b);b=a.url;null!=a.dispatchUrl&&(b+=a.dispatchUrl);var p=a.data;a.attachHeadersAsQueryString&&(b=J(a),""!==p&&(b+="&X-Atmosphere-Post-Body="+encodeURIComponent(p)),p="");u=jQuery.ajax({url:b,type:a.method,dataType:"jsonp",error:function(b,c,p){e.error=!0;a.openId&&clearTimeout(a.openId);a.reconnect&&B++<a.maxReconnectOnClose?(q("re-connecting",a.transport,a),z(u,a,a.reconnectInterval),a.openId=setTimeout(function(){T(a)},
a.reconnectInterval+1E3)):v(b.status,p)},jsonp:"jsonpTransport",success:function(b){if(a.reconnect)if(-1===a.maxRequest||a.requestCount++<a.maxRequest){U(u,a);a.executeCallbackBeforeReconnect||z(u,a,0);b=b.message;if(null!=b&&"string"!==typeof b)try{b=jQuery.stringifyJSON(b)}catch(p){}E(b,a,e)||G(e.responseBody,"messageReceived",200,a.transport);a.executeCallbackBeforeReconnect&&z(u,a,0)}else jQuery.atmosphere.log(c.logLevel,["JSONP reconnect maximum try reached "+c.requestCount]),v(0,"maxRequest reached")},
data:a.data,beforeSend:function(b){aa(b,a,!1)}})}function ma(b){var a=c;null!=b&&"undefined"!==typeof b&&(a=b);b=a.url;null!=a.dispatchUrl&&(b+=a.dispatchUrl);var p=a.data;a.attachHeadersAsQueryString&&(b=J(a),""!==p&&(b+="&X-Atmosphere-Post-Body="+encodeURIComponent(p)),p="");u=jQuery.ajax({url:b,type:a.method,error:function(b,c,p){e.error=!0;300>b.status?z(u,a):v(b.status,p)},success:function(b,p,d){a.reconnect&&(-1===a.maxRequest||a.requestCount++<a.maxRequest?(a.executeCallbackBeforeReconnect||
z(u,a,0),E(b,a,e)||G(e.responseBody,"messageReceived",200,a.transport),a.executeCallbackBeforeReconnect&&z(u,a,0)):(jQuery.atmosphere.log(c.logLevel,["AJAX reconnect maximum try reached "+c.requestCount]),v(0,"maxRequest reached")))},beforeSend:function(b){aa(b,a,!1)},crossDomain:a.enableXDR,async:"undefined"!==typeof a.async?a.async:!0})}function na(b){return null!=c.webSocketImpl?c.webSocketImpl:window.WebSocket?new WebSocket(b):new MozWebSocket(b)}function A(){var b=J(c);return decodeURI(jQuery('<a href="'+
b+'"/>')[0].href.replace(/^http/,"ws"))}function k(b){e.transport="sse";var a=J(c);"debug"===c.logLevel&&(jQuery.atmosphere.debug("Invoking executeSSE"),jQuery.atmosphere.debug("Using URL: "+a));if(c.enableProtocol&&b){var p=jQuery.now()-c.ctime;c.lastTimestamp=Number(c.stime)+Number(p)}if(b&&!c.reconnect)null!=y&&n();else{try{y=new EventSource(a,{withCredentials:c.withCredentials})}catch(f){v(0,f);L("SSE failed. Downgrading to fallback transport and resending");return}0<c.connectTimeout&&(c.id=setTimeout(function(){b||
n()},c.connectTimeout));y.onopen=function(a){H(c);"debug"===c.logLevel&&jQuery.atmosphere.debug("SSE successfully opened");c.enableProtocol?c.isReopen&&(c.isReopen=!1,q("re-opening",c.transport,c)):b?q("re-opening","sse",c):q("opening","sse",c);b=!0;"POST"===c.method&&(e.state="messageReceived",y.send(c.data))};y.onmessage=function(a){H(c);c.enableXDR||a.origin===window.location.protocol+"//"+window.location.host?(e.state="messageReceived",e.status=200,a=a.data,E(a,c,e)||(x(),e.responseBody="",e.messages=
[])):jQuery.atmosphere.log(c.logLevel,["Origin was not "+window.location.protocol+"//"+window.location.host])};y.onerror=function(a){clearTimeout(c.id);e.closedByClientTimeout||((M(b),n(),I)?jQuery.atmosphere.log(c.logLevel,["SSE closed normally"]):b?c.reconnect&&"sse"===e.transport&&(B++<c.maxReconnectOnClose?(q("re-connecting",c.transport,c),0<c.reconnectInterval?c.reconnectId=setTimeout(function(){k(!0)},c.reconnectInterval):k(!0),e.responseBody="",e.messages=[]):(jQuery.atmosphere.log(c.logLevel,
["SSE reconnect maximum try reached "+B]),v(0,"maxReconnectOnClose reached"))):L("SSE failed. Downgrading to fallback transport and resending"))}}}function Y(b){e.transport="websocket";if(c.enableProtocol&&b){var a=jQuery.now()-c.ctime;c.lastTimestamp=Number(c.stime)+Number(a)}a=A(c.url);"debug"===c.logLevel&&(jQuery.atmosphere.debug("Invoking executeWebSocket"),jQuery.atmosphere.debug("Using URL: "+a));if(b&&!c.reconnect)null!=l&&n();else if(l=na(a),null!=c.webSocketBinaryType&&(l.binaryType=c.webSocketBinaryType),
0<c.connectTimeout&&(c.id=setTimeout(function(){if(!b){l.onclose({code:1002,reason:"",wasClean:!1});try{n()}catch(a){}}},c.connectTimeout)),l.onopen=function(a){H(c);"debug"===c.logLevel&&jQuery.atmosphere.debug("Websocket successfully opened");a=b;b=!0;null!=l&&(l.webSocketOpened=b);c.enableProtocol||(a?q("re-opening","websocket",c):q("opening","websocket",c));null!=l&&"POST"===c.method&&(e.state="messageReceived",l.send(c.data))},l.onmessage=function(a){H(c);e.state="messageReceived";e.status=200;
a=a.data;"string"===typeof a?E(a,c,e)||(x(),e.responseBody="",e.messages=[]):ea(c,a)&&(e.responseBody=a,x(),e.responseBody=null)},l.onerror=function(a){clearTimeout(c.id)},l.onclose=function(a){if("closed"!==e.state){clearTimeout(c.id);var f=a.reason;if(""===f)switch(a.code){case 1E3:f="Normal closure; the connection successfully completed whatever purpose for which it was created.";break;case 1001:f="The endpoint is going away, either because of a server failure or because the browser is navigating away from the page that opened the connection.";
break;case 1002:f="The endpoint is terminating the connection due to a protocol error.";break;case 1003:f="The connection is being terminated because the endpoint received data of a type it cannot accept (for example, a text-only endpoint received binary data).";break;case 1004:f="The endpoint is terminating the connection because a data frame was received that is too large.";break;case 1005:f="Unknown: no status code was provided even though one was expected.";break;case 1006:f="Connection was closed abnormally (that is, with no close frame being sent)."}"warn"===
c.logLevel&&(jQuery.atmosphere.warn("Websocket closed, reason: "+f),jQuery.atmosphere.warn("Websocket closed, wasClean: "+a.wasClean));e.closedByClientTimeout||((M(b),e.state="closed",I)?jQuery.atmosphere.log(c.logLevel,["Websocket closed normally"]):b?c.reconnect&&"websocket"===e.transport&&(n(),B++<c.maxReconnectOnClose?(q("re-connecting",c.transport,c),0<c.reconnectInterval?c.reconnectId=setTimeout(function(){e.responseBody="";e.messages=[];Y(!0)},c.reconnectInterval):(e.responseBody="",e.messages=
[],Y(!0))):(jQuery.atmosphere.log(c.logLevel,["Websocket reconnect maximum try reached "+c.requestCount]),"warn"===c.logLevel&&jQuery.atmosphere.warn("Websocket error, reason: "+a.reason),v(0,"maxReconnectOnClose reached"))):L("Websocket failed. Downgrading to Comet and resending"))}},void 0===l.url)l.onclose({reason:"Android 4.1 does not support websockets.",wasClean:!1})}function ea(b,a){var c=!0;if("polling"===b.transport)return c;if(0!==jQuery.trim(a).length&&b.enableProtocol&&b.firstMessage){b.firstMessage=
!1;var c=a.split(b.messageDelimiter),e=2===c.length?0:1;b.uuid=jQuery.trim(c[e]);b.stime=jQuery.trim(c[e+1]);c=!1;"long-polling"!==b.transport&&T(b);jQuery.atmosphere.uuid=b.uuid}else b.enableProtocol&&b.firstMessage?c=!1:T(b);return c}function H(b){clearTimeout(b.id);0<b.timeout&&"polling"!==b.transport&&(b.id=setTimeout(function(){e.closedByClientTimeout=!0;e.state="closedByClient";e.responseBody="";e.status=408;e.messages=[];x();V();n()},b.timeout))}function v(b,a){n();clearTimeout(c.id);e.state=
"error";e.reasonPhrase=a;e.responseBody="";e.status=b;e.messages=[];x()}function E(b,a,c){if(!ea(a,b)||0===b.length)return!0;if(a.trackMessageLength){b=c.partialMessage+b;for(var e=[],d=b.indexOf(a.messageDelimiter);-1!==d;){var g=jQuery.trim(b.substring(0,d)),r=parseInt(g,10);if(isNaN(r))throw'message length "'+g+'" is not a number';d+=a.messageDelimiter.length;d+r>b.length?d=-1:(e.push(b.substring(d,d+r)),b=b.substring(d+r,b.length),d=b.indexOf(a.messageDelimiter))}c.partialMessage=b;if(0!==e.length)c.responseBody=
e.join(a.messageDelimiter),c.messages=e;else return c.responseBody="",c.messages=[],!0}else c.responseBody=b;return!1}function L(b){jQuery.atmosphere.log(c.logLevel,[b]);if("undefined"!==typeof c.onTransportFailure)c.onTransportFailure(b,c);else if("undefined"!==typeof jQuery.atmosphere.onTransportFailure)jQuery.atmosphere.onTransportFailure(b,c);c.transport=c.fallbackTransport;b=-1===c.connectTimeout?0:c.connectTimeout;c.reconnect&&"none"!==c.transport||null==c.transport?(c.method=c.fallbackMethod,
e.transport=c.fallbackTransport,c.fallbackTransport="none",0<b?c.reconnectId=setTimeout(function(){h()},b):h()):v(500,"Unable to reconnect with fallback transport")}function J(b,a){var d=c;null!=b&&"undefined"!==typeof b&&(d=b);null==a&&(a=d.url);if(!d.attachHeadersAsQueryString||-1!==a.indexOf("X-Atmosphere-Framework"))return a;a+=-1!==a.indexOf("?")?"&":"?";a+="X-Atmosphere-tracking-id="+d.uuid;a+="&X-Atmosphere-Framework="+jQuery.atmosphere.version;a+="&X-Atmosphere-Transport="+d.transport;d.trackMessageLength&&
(a+="&X-Atmosphere-TrackMessageSize=true");a=null!=d.lastTimestamp?a+("&X-Cache-Date="+d.lastTimestamp):a+"&X-Cache-Date=0";""!==d.contentType&&(a+="&Content-Type="+encodeURIComponent(d.contentType));d.enableProtocol&&(a+="&X-atmo-protocol=true");jQuery.each(d.headers,function(c,g){var h=jQuery.isFunction(g)?g.call(this,d,b,e):g;null!=h&&(a+="&"+encodeURIComponent(c)+"="+encodeURIComponent(h))});return a}function T(b){b.isOpen?b.isReopen&&(b.isReopen=!1,q("re-opening",b.transport,b)):(b.isOpen=!0,
q("opening",b.transport,b))}function Q(b){var a=c;if(null!=b||"undefined"!==typeof b)a=b;a.lastIndex=0;a.readyState=0;if("jsonp"===a.transport||a.enableXDR&&jQuery.atmosphere.checkCORSSupport())da(a);else if("ajax"===a.transport)ma(b);else{if(jQuery.browser.msie&&10>+jQuery.browser.version.split(".")[0]){if("streaming"===a.transport){a.enableXDR&&window.XDomainRequest?O(a):P(a);return}if(a.enableXDR&&window.XDomainRequest){O(a);return}}var d=function(){a.lastIndex=0;a.reconnect&&B++<a.maxReconnectOnClose?
(q("re-connecting",b.transport,b),z(f,a,b.reconnectInterval)):v(0,"maxReconnectOnClose reached")};if(a.reconnect&&(-1===a.maxRequest||a.requestCount++<a.maxRequest)){var f=jQuery.ajaxSettings.xhr();f.hasData=!1;aa(f,a,!0);a.suspend&&(K=f);"polling"!==a.transport&&(e.transport=a.transport,f.onabort=function(){M(!0)},f.onerror=function(){e.error=!0;try{e.status=XMLHttpRequest.status}catch(a){e.status=500}e.status||(e.status=500);e.errorHandled||(n(),d())});f.onreadystatechange=function(){if(!I){e.error=
null;var g=!1,h=!1;if("streaming"===a.transport&&2<a.readyState&&4===f.readyState)n(),d();else{a.readyState=f.readyState;"streaming"===a.transport&&3<=f.readyState?h=!0:"long-polling"===a.transport&&4===f.readyState&&(h=!0);H(c);if("polling"!==a.transport){var r=200;4===f.readyState&&(r=1E3<f.status?0:f.status);if(300<=r||0===r){e.errorHandled=!0;n();d();return}a.enableProtocol&&b.firstMessage||2!==f.readyState||T(a)}else 4===f.readyState&&(h=!0);if(h)if(h=f.responseText,0===jQuery.trim(h).length&&
"long-polling"===a.transport)f.hasData?f.hasData=!1:z(f,a,0);else{f.hasData=!0;U(f,c);if("streaming"===a.transport)if(jQuery.browser.opera)jQuery.atmosphere.iterate(function(){if(500!==e.status&&f.responseText.length>a.lastIndex){try{e.status=f.status,e.headers=t(f.getAllResponseHeaders()),U(f,c)}catch(b){e.status=404}H(c);e.state="messageReceived";var d=f.responseText.substring(a.lastIndex);a.lastIndex=f.responseText.length;(g=E(d,a,e))||x();fa(f,a)}else if(400<e.status)return a.lastIndex=f.responseText.length,
!1},0);else{if(r=h.substring(a.lastIndex,h.length),g=E(r,a,e),a.lastIndex=h.length,g)return}else g=E(h,a,e);try{e.status=f.status,e.headers=t(f.getAllResponseHeaders()),U(f,a)}catch(k){e.status=404}e.state=a.suspend?0===e.status?"closed":"messageReceived":"messagePublished";(h="streaming"!==b.transport&&"polling"!==b.transport)&&!a.executeCallbackBeforeReconnect&&z(f,a,0);0===e.responseBody.length||g||x();h&&a.executeCallbackBeforeReconnect&&z(f,a,0);fa(f,a)}}}};f.send(a.data);X=!0}else"debug"===
a.logLevel&&jQuery.atmosphere.log(a.logLevel,["Max re-connection reached."]),v(0,"maxRequest reached")}}function aa(b,a,d){var f=a.url;null!=a.dispatchUrl&&"POST"===a.method&&(f+=a.dispatchUrl);f=J(a,f);f=jQuery.atmosphere.prepareURL(f);d&&(b.open(a.method,f,!0),0<a.connectTimeout&&(a.id=setTimeout(function(){0===a.requestCount&&(n(),G("Connect timeout","closed",200,a.transport))},a.connectTimeout)));c.withCredentials&&"withCredentials"in b&&(b.withCredentials=!0);c.dropHeaders||(b.setRequestHeader("X-Atmosphere-Framework",
jQuery.atmosphere.version),b.setRequestHeader("X-Atmosphere-Transport",a.transport),null!=a.lastTimestamp?b.setRequestHeader("X-Cache-Date",a.lastTimestamp):b.setRequestHeader("X-Cache-Date",0),a.trackMessageLength&&b.setRequestHeader("X-Atmosphere-TrackMessageSize","true"),b.setRequestHeader("X-Atmosphere-tracking-id",a.uuid),jQuery.each(a.headers,function(c,f){var g=jQuery.isFunction(f)?f.call(this,b,a,d,e):f;null!=g&&b.setRequestHeader(c,g)}));""!==a.contentType&&b.setRequestHeader("Content-Type",
a.contentType)}function z(b,a,d){if(a.reconnect||a.suspend&&X){var f=0;0!==b.readyState&&(f=1E3<b.status?0:b.status);e.status=0===f?204:f;e.reason=0===f?"Server resumed the connection or down.":"OK";clearTimeout(a.id);a.reconnectId&&(clearTimeout(a.reconnectId),delete a.reconnectId);0<d?setTimeout(function(){c.reconnectId=Q(a)},d):Q(a)}}function la(b){b.state="re-connecting";ga(b)}function O(b){"polling"!==b.transport?(C=ha(b),C.open()):ha(b).open()}function ha(b){var a=c;null!=b&&"undefined"!==typeof b&&
(a=b);var d=a.transport,f=0,g=new window.XDomainRequest,h=function(){"long-polling"===a.transport&&a.reconnect&&(-1===a.maxRequest||a.requestCount++<a.maxRequest)&&(g.status=200,O(a))},r=a.rewriteURL||function(a){var b=/(?:^|;\s*)(JSESSIONID|PHPSESSID)=([^;]*)/.exec(document.cookie);switch(b&&b[1]){case "JSESSIONID":return a.replace(/;jsessionid=[^\?]*|(\?)|$/,";jsessionid="+b[2]+"$1");case "PHPSESSID":return a.replace(/\?PHPSESSID=[^&]*&?|\?|$/,"?PHPSESSID="+b[2]+"&").replace(/&$/,"")}return a};
g.onprogress=function(){clearTimeout(a.id);var b=g.responseText,b=b.substring(f);f+=b.length;if("polling"!==d){H(a);var c=E(b,a,e);if("long-polling"!==d||0!==jQuery.trim(b).length)a.executeCallbackBeforeReconnect&&h(),c||G(e.responseBody,"messageReceived",200,d),a.executeCallbackBeforeReconnect||h()}};g.onerror=function(){"polling"!==a.transport&&(n(),B++<a.maxReconnectOnClose?0<a.reconnectInterval?a.reconnectId=setTimeout(function(){q("re-connecting",b.transport,b);O(a)},a.reconnectInterval):(q("re-connecting",
b.transport,b),O(a)):v(0,"maxReconnectOnClose reached"))};g.onload=function(){};return{open:function(){var b=a.url;null!=a.dispatchUrl&&(b+=a.dispatchUrl);b=J(a,b);g.open(a.method,r(b));"GET"===a.method?g.send():g.send(a.data);0<a.connectTimeout&&(a.id=setTimeout(function(){0===a.requestCount&&(n(),G("Connect timeout","closed",200,a.transport))},a.connectTimeout))},close:function(){g.abort()}}}function P(b){C=oa(b);C.open()}function oa(b){var a=c;null!=b&&"undefined"!==typeof b&&(a=b);var d,f=new window.ActiveXObject("htmlfile");
f.open();f.close();var g=a.url;null!=a.dispatchUrl&&(g+=a.dispatchUrl);"polling"!==a.transport&&(e.transport=a.transport);return{open:function(){var b=f.createElement("iframe");g=J(a);""!==a.data&&(g+="&X-Atmosphere-Post-Body="+encodeURIComponent(a.data));g=jQuery.atmosphere.prepareURL(g);b.src=g;f.body.appendChild(b);var h=b.contentDocument||b.contentWindow.document;d=jQuery.atmosphere.iterate(function(){try{if(h.firstChild){if("complete"===h.readyState)try{jQuery.noop(h.fileSize)}catch(b){return G("Connection Failure",
"error",500,a.transport),!1}var g=h.body?h.body.lastChild:h,k=function(){var a=g.cloneNode(!0);a.appendChild(h.createTextNode("."));a=a.innerText;return a=a.substring(0,a.length-1)};if(!jQuery.nodeName(g,"pre")){var l=h.head||h.getElementsByTagName("head")[0]||h.documentElement||h,n=h.createElement("script");n.text="document.write('<plaintext>')";l.insertBefore(n,l.firstChild);l.removeChild(n);g=h.body.lastChild}a.closed&&(a.isReopen=!0);d=jQuery.atmosphere.iterate(function(){var b=k();if(b.length>
a.lastIndex){H(c);e.status=200;e.error=null;g.innerText="";if(E(b,a,e))return"";G(e.responseBody,"messageReceived",200,a.transport)}a.lastIndex=0;if("complete"===h.readyState)return M(!0),q("re-connecting",a.transport,a),0<a.reconnectInterval?a.reconnectId=setTimeout(function(){P(a)},a.reconnectInterval):P(a),!1},null);return!1}}catch(m){return e.error=!0,q("re-connecting",a.transport,a),B++<a.maxReconnectOnClose?0<a.reconnectInterval?a.reconnectId=setTimeout(function(){P(a)},a.reconnectInterval):
P(a):v(0,"maxReconnectOnClose reached"),f.execCommand("Stop"),f.close(),!1}})},close:function(){d&&d();f.execCommand("Stop");M(!0)}}}function Z(b){null!=w?w.send(b):null!=K||null!=y?W(b):null!=C?c.enableXDR&&jQuery.atmosphere.checkCORSSupport()?(b=ia(b),b.reconnect=!1,da(b)):W(b):null!=u?W(b):null!=l?pa(b):(v(0,"No suspended connection available"),jQuery.atmosphere.error("No suspended connection available. Make sure atmosphere.subscribe has been called and request.onOpen invoked before invoking this method"))}
function W(b){b=ia(b);Q(b)}function ja(b){var a=b;"object"===typeof a&&(a=b.data);return a}function ia(b){var a=ja(b),a={connected:!1,timeout:6E4,method:"POST",url:c.url,contentType:c.contentType,headers:c.headers,reconnect:!0,callback:null,data:a,suspend:!1,maxRequest:-1,logLevel:"info",requestCount:0,withCredentials:c.withCredentials,transport:"polling",isOpen:!0,attachHeadersAsQueryString:!0,enableXDR:c.enableXDR,uuid:c.uuid,dispatchUrl:c.dispatchUrl,enableProtocol:!1,messageDelimiter:"|",maxReconnectOnClose:c.maxReconnectOnClose};
"object"===typeof b&&(a=jQuery.extend(a,b));return a}function pa(b){var a=jQuery.atmosphere.isBinary(b)?b:ja(b),e;try{e=null!=c.dispatchUrl?c.webSocketPathDelimiter+c.dispatchUrl+c.webSocketPathDelimiter+a:a,l.webSocketOpened?l.send(e):jQuery.atmosphere.error("WebSocket not connected.")}catch(d){l.onclose=function(a){},n(),L("Websocket failed. Downgrading to Comet and resending "+e),W(b)}}function ba(b){b=jQuery.parseJSON(b);if(b.id!==F)if("undefined"!==typeof c.onLocalMessage)c.onLocalMessage(b.event);
else if("undefined"!==typeof jQuery.atmosphere.onLocalMessage)jQuery.atmosphere.onLocalMessage(b.event)}function G(b,a,c,d){e.responseBody=b;e.transport=d;e.status=c;e.state=a;x()}function U(b,a){if(a.readResponsesHeaders)try{var c=b.getResponseHeader("X-Cache-Date");c&&null!=c&&0<c.length&&(a.lastTimestamp=c.split(" ").pop());var e=b.getResponseHeader("X-Atmosphere-tracking-id");e&&null!=e&&(a.uuid=e.split(" ").pop())}catch(d){}else a.enableProtocol||(a.lastTimestamp=jQuery.now(),a.uuid=jQuery.atmosphere.guid())}
function ga(b){ka(b,c);ka(b,jQuery.atmosphere)}function ka(b,a){switch(b.state){case "messageReceived":B=0;if("undefined"!==typeof a.onMessage)a.onMessage(b);break;case "error":if("undefined"!==typeof a.onError)a.onError(b);break;case "opening":delete c.closed;if("undefined"!==typeof a.onOpen)a.onOpen(b);break;case "messagePublished":if("undefined"!==typeof a.onMessagePublished)a.onMessagePublished(b);break;case "re-connecting":if("undefined"!==typeof a.onReconnect)a.onReconnect(c,b);break;case "closedByClient":if("undefined"!==
typeof a.onClientTimeout)a.onClientTimeout(c);break;case "re-opening":delete c.closed;if("undefined"!==typeof a.onReopen)a.onReopen(c,b);break;case "fail-to-reconnect":if("undefined"!==typeof a.onFailureToReconnect)a.onFailureToReconnect(c,b);break;case "unsubscribe":case "closed":var e="undefined"!==typeof c.closed?c.closed:!1;if("undefined"!==typeof a.onClose&&!e)a.onClose(b);c.closed=!0}}function M(b){"closed"!==e.state&&(e.state="closed",e.responseBody="",e.messages=[],e.status=b?200:501,x())}
function x(){var b=function(a,b){b(e)};null==w&&null!=N&&N(e.responseBody);c.reconnect=c.mrequest;for(var a="string"===typeof e.responseBody,d=a&&c.trackMessageLength?0<e.messages.length?e.messages:[""]:Array(e.responseBody),f=0;f<d.length;f++)if(!(1<d.length&&0===d[f].length)&&(e.responseBody=a?jQuery.trim(d[f]):d[f],null==w&&null!=N&&N(e.responseBody),0!==e.responseBody.length||"messageReceived"!==e.state)){ga(e);if(0<jQuery.atmosphere.callbacks.length){"debug"===c.logLevel&&jQuery.atmosphere.debug("Invoking "+
jQuery.atmosphere.callbacks.length+" global callbacks: "+e.state);try{jQuery.each(jQuery.atmosphere.callbacks,b)}catch(g){jQuery.atmosphere.log(c.logLevel,["Callback exception"+g])}}if("function"===typeof c.callback){"debug"===c.logLevel&&jQuery.atmosphere.debug("Invoking request callbacks");try{c.callback(e)}catch(h){jQuery.atmosphere.log(c.logLevel,["Callback exception"+h])}}}}function fa(b,a){""===e.partialMessage&&"streaming"===a.transport&&b.responseText.length>a.maxStreamingLength&&(e.messages=
[],M(!0),V(),n(),z(b,a,0))}function V(){if(c.enableProtocol&&!c.firstMessage){var b="X-Atmosphere-Transport=close&X-Atmosphere-tracking-id="+c.uuid;jQuery.each(c.headers,function(a,d){var g=jQuery.isFunction(d)?d.call(this,c,c,e):d;null!=g&&(b+="&"+encodeURIComponent(a)+"="+encodeURIComponent(g))});var a=c.url.replace(/([?&])_=[^&]*/,b),a=a+(a===c.url?(/\?/.test(c.url)?"&":"?")+b:"");0<c.connectTimeout?jQuery.ajax({url:a,async:!0,timeout:c.connectTimeout,cache:!1}):jQuery.ajax({url:a,async:!0,cache:!1})}}
function R(){c.reconnectId&&(clearTimeout(c.reconnectId),delete c.reconnectId);c.reconnect=!1;I=!0;e.request=c;e.state="unsubscribe";e.responseBody="";e.status=408;x();V();n()}function n(){c.id&&clearTimeout(c.id);null!=C&&(C.close(),C=null);null!=u&&(u.abort(),u=null);null!=K&&(K.abort(),K=null);null!=l&&(l.webSocketOpened&&l.close(),l=null);null!=y&&(y.close(),y=null);null!=D&&(clearInterval(S),document.cookie=$+"=; expires=Thu, 01 Jan 1970 00:00:00 GMT; path=/",D.signal("close",{reason:"",heir:I?
(D.get("children")||[])[0]:F}),D.close());null!=w&&w.close()}var c={timeout:3E5,method:"GET",headers:{},contentType:"",callback:null,url:"",data:"",suspend:!0,maxRequest:-1,reconnect:!0,maxStreamingLength:1E7,lastIndex:0,logLevel:"info",requestCount:0,fallbackMethod:"GET",fallbackTransport:"streaming",transport:"long-polling",webSocketImpl:null,webSocketBinaryType:null,dispatchUrl:null,webSocketPathDelimiter:"@@",enableXDR:!1,rewriteURL:!1,attachHeadersAsQueryString:!0,executeCallbackBeforeReconnect:!1,
readyState:0,lastTimestamp:0,withCredentials:!1,trackMessageLength:!1,messageDelimiter:"|",connectTimeout:-1,reconnectInterval:0,dropHeaders:!0,uuid:0,shared:!1,readResponsesHeaders:!1,maxReconnectOnClose:5,enableProtocol:!0,onError:function(b){},onClose:function(b){},onOpen:function(b){},onMessage:function(b){},onReopen:function(b,a){},onReconnect:function(b,a){},onMessagePublished:function(b){},onTransportFailure:function(b,a){},onLocalMessage:function(b){},onFailureToReconnect:function(b,a){},
onClientTimeout:function(b){}},e={status:200,reasonPhrase:"OK",responseBody:"",messages:[],headers:[],state:"messageReceived",transport:"polling",error:null,request:null,partialMessage:"",errorHandled:!1,closedByClientTimeout:!1},l=null,y=null,K=null,C=null,u=null,X=!0,B=0,I=!1,N=null,D,w=null,F=jQuery.now(),S,$;g(d);this.subscribe=function(b){g(b);h()};this.execute=function(){h()};this.invokeCallback=function(){x()};this.close=function(){R()};this.disconnect=function(){V()};this.getUrl=function(){return c.url};
this.push=function(b,a){if(null!=a){var e=c.dispatchUrl;c.dispatchUrl=a;Z(b);c.dispatchUrl=e}else Z(b)};this.getUUID=function(){return c.uuid};this.pushLocal=function(b){if(0!==b.length)try{w?w.localSend(b):D&&D.signal("localMessage",jQuery.stringifyJSON({id:F,event:b}))}catch(a){jQuery.atmosphere.error(a)}};this.enableProtocol=function(b){return c.enableProtocol};this.request=c;this.response=e},subscribe:function(d,g,h){"function"===typeof g&&jQuery.atmosphere.addCallback(g);jQuery.atmosphere.uuid=
0;"string"!==typeof d?h=d:h.url=d;d=new jQuery.atmosphere.AtmosphereRequest(h);d.execute();return jQuery.atmosphere.requests[jQuery.atmosphere.requests.length]=d},addCallback:function(d){-1===jQuery.inArray(d,jQuery.atmosphere.callbacks)&&jQuery.atmosphere.callbacks.push(d)},removeCallback:function(d){d=jQuery.inArray(d,jQuery.atmosphere.callbacks);-1!==d&&jQuery.atmosphere.callbacks.splice(d,1)},unsubscribe:function(){if(0<jQuery.atmosphere.requests.length)for(var d=[].concat(jQuery.atmosphere.requests),
g=0;g<d.length;g++){var h=d[g];h.close();clearTimeout(h.response.request.id)}jQuery.atmosphere.requests=[];jQuery.atmosphere.callbacks=[]},unsubscribeUrl:function(d){var g=-1;if(0<jQuery.atmosphere.requests.length)for(var h=0;h<jQuery.atmosphere.requests.length;h++){var m=jQuery.atmosphere.requests[h];if(m.getUrl()===d){m.close();clearTimeout(m.response.request.id);g=h;break}}0<=g&&jQuery.atmosphere.requests.splice(g,1)},publish:function(d){"function"===typeof d.callback&&jQuery.atmosphere.addCallback(d.callback);
d.transport="polling";d=new jQuery.atmosphere.AtmosphereRequest(d);return jQuery.atmosphere.requests[jQuery.atmosphere.requests.length]=d},checkCORSSupport:function(){return jQuery.browser.msie&&!window.XDomainRequest||jQuery.browser.opera&&12>+jQuery.browser.version.split(".")[0]||"KreaTVWebKit/531"===jQuery.trim(navigator.userAgent).slice(0,16)||"kreatel"===jQuery.trim(navigator.userAgent).slice(-7).toLowerCase()?!0:-1<navigator.userAgent.toLowerCase().indexOf("android")?!0:!1},S4:function(){return(65536*
(1+Math.random())|0).toString(16).substring(1)},guid:function(){return jQuery.atmosphere.S4()+jQuery.atmosphere.S4()+"-"+jQuery.atmosphere.S4()+"-"+jQuery.atmosphere.S4()+"-"+jQuery.atmosphere.S4()+"-"+jQuery.atmosphere.S4()+jQuery.atmosphere.S4()+jQuery.atmosphere.S4()},prepareURL:function(d){var g=jQuery.now(),h=d.replace(/([?&])_=[^&]*/,"$1_="+g);return h+(h===d?(/\?/.test(d)?"&":"?")+"_="+g:"")},param:function(d){return jQuery.param(d,jQuery.ajaxSettings.traditional)},supportStorage:function(){var d=
window.localStorage;if(d)try{return d.setItem("t","t"),d.removeItem("t"),window.StorageEvent&&!jQuery.browser.msie&&!(jQuery.browser.mozilla&&"1"===jQuery.browser.version.split(".")[0])}catch(g){}return!1},iterate:function(d,g){var h;g=g||0;(function s(){h=setTimeout(function(){!1!==d()&&s()},g)})();return function(){clearTimeout(h)}},log:function(d,g){if(window.console){var h=window.console[d];"function"===typeof h&&h.apply(window.console,g)}},warn:function(){jQuery.atmosphere.log("warn",arguments)},
info:function(){jQuery.atmosphere.log("info",arguments)},debug:function(){jQuery.atmosphere.log("debug",arguments)},error:function(){jQuery.atmosphere.log("error",arguments)},isBinary:function(d){return/^\[object\s(?:Blob|ArrayBuffer|.+Array)\]$/.test(Object.prototype.toString.call(d))}}}();
(function(){var t,d;jQuery.uaMatch=function(d){d=d.toLowerCase();d=/(chrome)[ \/]([\w.]+)/.exec(d)||/(webkit)[ \/]([\w.]+)/.exec(d)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(d)||/(msie) ([\w.]+)/.exec(d)||/(trident)(?:.*? rv:([\w.]+)|)/.exec(d)||0>d.indexOf("compatible")&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(d)||[];return{browser:d[1]||"",version:d[2]||"0"}};t=jQuery.uaMatch(navigator.userAgent);d={};t.browser&&(d[t.browser]=!0,d.version=t.version);d.chrome?d.webkit=!0:d.webkit&&(d.safari=!0);d.trident&&
(d.msie=!0);jQuery.browser=d;jQuery.sub=function(){function d(h,s){return new d.fn.init(h,s)}jQuery.extend(!0,d,this);d.superclass=this;d.fn=d.prototype=this();d.fn.constructor=d;d.sub=this.sub;d.fn.init=function(m,s){s&&s instanceof jQuery&&!(s instanceof d)&&(s=d(s));return jQuery.fn.init.call(this,m,s,h)};d.fn.init.prototype=d.fn;var h=d(document);return d}})();
(function(t){function d(d){return'"'+d.replace(m,function(d){var g=s[d];return"string"===typeof g?g:"\\u"+("0000"+d.charCodeAt(0).toString(16)).slice(-4)})+'"'}function g(d){return 10>d?"0"+d:d}function h(q,s){var m,t,A,k=s[q];A=typeof k;k&&"object"===typeof k&&"function"===typeof k.toJSON&&(k=k.toJSON(q),A=typeof k);switch(A){case "string":return d(k);case "number":return isFinite(k)?String(k):"null";case "boolean":return String(k);case "object":if(!k)return"null";switch(Object.prototype.toString.call(k)){case "[object Date]":return isFinite(k.valueOf())?
'"'+k.getUTCFullYear()+"-"+g(k.getUTCMonth()+1)+"-"+g(k.getUTCDate())+"T"+g(k.getUTCHours())+":"+g(k.getUTCMinutes())+":"+g(k.getUTCSeconds())+'Z"':"null";case "[object Array]":t=k.length;A=[];for(m=0;m<t;m++)A.push(h(m,k)||"null");return"["+A.join(",")+"]";default:A=[];for(m in k)Object.prototype.hasOwnProperty.call(k,m)&&(t=h(m,k))&&A.push(d(m)+":"+t);return"{"+A.join(",")+"}"}}}var m=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
s={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};t.stringifyJSON=function(d){return window.JSON&&window.JSON.stringify?window.JSON.stringify(d):h("",{"":d})}})(jQuery);